function My_Bar_GoTo(name, subdom, action, URL)
{    
    var goURL = "";
    goURL = My_Bar_GetURL(name, subdom, action, URL);
    
    // Load the URL in the browser window
    My_Bar_LoadURL(goURL);
}

function My_Bar_GetURL(name, subdom, action, URL)
{
    var goURL = URL;
    
    if (isEmpty(goURL)){
        if (isEmpty(subdom)) subdom = name;
        if (isEmpty(action)) action = name;
        goURL = "http://" + subdom + ".myspace.com/index.cfm?fuseaction=" + action;
    }
    
    return goURL;
}

function My_Bar_GetID(ID, name)
{
    if (isEmpty(ID)){
        var aTemp = name.split(" ");  // creates an array by splitting the string at each space
        var name = aTemp.join("_");
        ID = name;
    }
    
    ID = "My_Bar-" + ID;
    
    return ID;
}

function My_Bar_BuildURL(URL){

    if (URL == "http://www.myspace.com/index.cfm?fuseaction=user.viewProfile" ||
        URL == "http://comments.myspace.com/index.cfm?fuseaction=user.HomeComments" ||
        URL == "http://groups.myspace.com/index.cfm?fuseaction=groups.myGroups"){
        var userID = My_Bar_GetUserID();
        if (userID == ""){ return ""; }
        URL = URL + "&friendID=" + userID;
    }
    return URL;
}

function My_Bar_LoadURL(URL)
{
    URL = My_Bar_BuildURL(URL);
    
    if (URL == ""){ return; }
    // Set the document's location to the incoming URL
    window._content.document.location = URL;
    
    // Make sure we get the focus
    window.content.focus();
}

function My_Bar_GetUserID()
{
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

  var userID = "";
  if (prefs.getPrefType("myspacebar.userinfo.userID") == prefs.PREF_STRING){
    userID = prefs.getCharPref("myspacebar.userinfo.userID");
  }
  if (isNaN(userID) || userID == ""){ 
      userID = My_Bar_GetUserInfo();
      if (isNaN(userID) || userID == ""){ return ""; }
  }
  return userID;
}

function My_Bar_SetUserID(userID)
{
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
    prefs.setCharPref("myspacebar.userinfo.userID",userID);
}

function My_Bar_EnterUserID()
{
    var userID = prompt("Some toolbar links require your UserID to work. " +
        "Your UserID is the number after 'friendID' when your visit your own profile.\n" +
        "Please enter your UserID to enable this link, " +
        "or you can copy and paste your 'View Profile' link from your Home page.",
        "http://www.myspace.com/index.cfm?fuseaction=user.viewProfile" +
        "&friendID=xxxxxxxx&Mytoken=xxxxxxxxxxxxxx");
    if (userID == "" || userID == null ||
        (userID == "http://www.myspace.com/index.cfm?fuseaction=user.viewProfile" + 
        "&friendID=xxxxxxxx&Mytoken=xxxxxxxxxxxxxx")){ return false; } 
    else if (isNaN(userID)){
        var reg = /friendID.([0-9]+)/;
        var ar = reg.exec(userID);
        userID = ar[1];
    }
        
    if (isNaN(userID)){
        alert("That is not a valid Myspace UserID or Profile URL.\n" +
            "Please try again or visit the Myspacebar homepage for help.");
        return false;
    }
    
    My_Bar_SetUserID(userID);
    return userID;
    
}

function My_Bar_GetUserInfo()
{
    // currently gets friendID to complete View Profile link and other links.
    // may be used to display other information in future versions, such as new mail notifications

    const SERVER_URL = "http://home.myspace.com/index.cfm?fuseaction=user";
    //var regProfileViews = /Profile\sViews:.*\r\n.*<font.*?>(.*?)<\/font>/
    //var regNetwork = /Your\sNetwork:.*\r\n.*<font.*?>(.*?)<\/font>/
    //var regLastLogin = /Last\sLogin:.*\r\n.*<font.*?>(.*?)<\/font>/
    var regUserID = /<a\shref.*?friendID.(.*?)&.*?>View\sMy\sProfile<\/a>/
    //var regName = /<span\sclass..whitetext15.>.*?Hello,\s(.*?)!<\/span>/
    //var regFriendsCount = /You\shave\s<a\shref.*?>(.*?)<\/a>\sfriends/
    //var regUnreadMailCount = /<td width.30 bgcolor..E8F1FA.>.*?\r\n.*?\r\n.*?Unread.*?\r\n.*?\r\n.*?<\/td>/
    //var regGetPicture = /<table.*?>.*?\r\n.*?<tr>.*?\r\n.*?<td.*?><a.*?imageID.(.*?)&Mytoken.*?><img.*?src..(.*?jpg).*?><\/a><br><br><\/td>.*?\r\n.*?<\/tr>.*?\r\n.*?\r\n.*?<tr>.*?\r\n.*?<td>.*?\r\n.*?\r\n.*?<center>(.*?)<\/center>.*?\r\n.*?<br>/
    
    //Try to create our XMLHttpRequest Object
    try {
        var httpRequest = new XMLHttpRequest();
    }catch (e){
        // alert('Error creating the connection!');
        return "";
    }
    //Make the connection and send our data
    try {
        //Two options here, only uncomment one of these
        //GET REQUEST
        httpRequest.open("GET", SERVER_URL, false, null, null);  

        //POST REQUEST EXAMPLE
        /*
        httpRequest.open("POST", SERVER_URL, false, null, null);  
        httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
        */
        httpRequest.send('');
    }catch (e){
        // alert('An error has occured calling the external site: '+e);
        return "";
    } 
    
    //Make sure we received a valid response
    switch(httpRequest.readyState) {
        case 1,2,3:
            // alert('Bad Ready State: '+httpRequest.status);
            return "";
            break;
        case 4:
            if(httpRequest.status !=200) {
                // alert('The server respond with a bad status code: '+httpRequest.status);
                return "";
            } else {
                var response = httpRequest.responseText;
            }
        break;
    }
    var ar = regUserID.exec(response);
    userID = ar[1];
    My_Bar_SetUserID(userID);
    return userID;
}